/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.executor.objectmodel;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.gson.JsonObject;

import ru.entaxy.platform.base.objects.EntaxyObject.FIELDS;


public abstract class AbstractFactored extends AbstractItem {

	private static final Logger log = LoggerFactory.getLogger(AbstractFactored.class);
	
	public static boolean isFactored(JsonObject jsonObject) {
		if (jsonObject.has(FIELDS.FACTORY_ID)) {
			String factoryId = jsonObject.get(FIELDS.FACTORY_ID).getAsString();
			return (factoryId != null) && !factoryId.isBlank(); 
		}
		return false;
	} 

	public static AbstractFactored getContextOwner(Map<String, Object> context) {
		initContext(context);
		@SuppressWarnings("unchecked")
		List<AbstractFactored> list = (List<AbstractFactored>)context.get(FACTORED_CONTEXT_KEY); 
		if (!list.isEmpty()) {
			return list.get(list.size()-1);
		}
		return null;
	}

	
	public String factoryId;
	public String scope = "public";
	public String ownScope = "";

	public List<AbstractItem> internalItems = new ArrayList<>();
	
	protected AbstractFactored(ObjectModel objectModel) {
		super(objectModel);
	}

	public void addInternal(AbstractItem item) {
		if (!this.internalItems.contains(item))
			this.internalItems.add(item);
	}
	
	public List<AbstractItem> getInternals(){
		return this.internalItems;
	}
	
	protected void joinContext(Map<String, Object> context) {
		initContext(context);
		@SuppressWarnings("unchecked")
		List<AbstractFactored> list = (List<AbstractFactored>)context.get(FACTORED_CONTEXT_KEY);
		list.add(this);
	}

	protected void leaveContext(Map<String, Object> context) {
		initContext(context);
		@SuppressWarnings("unchecked")
		List<AbstractFactored> list = (List<AbstractFactored>)context.get(FACTORED_CONTEXT_KEY);
		list.remove(this);
	}

	public void wrap(JsonObject object, Map<String, Object> context, String path) {
		super.wrap(object, context, path);
		this.factoryId = object.has(FIELDS.FACTORY_ID)?object.get(FIELDS.FACTORY_ID).getAsString():null;
		log.debug("WRAPPING FOR :: " + this.factoryId + "[" + jsonPath + "]");
	}
	
}
